#include <bits/stdc++.h>
using namespace std;
#define ll long long

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    ll n, k, ans = 0, sm = 0;
    cin >> n >> k;
    multiset<ll> st;
    vector<ll> v(n);
    for (auto& x : v)
        cin >> x;
    for (ll i = 0; i < n; i++)
    {
        ll res = (i + 1) + sm + v[i]; 
        ans = max(ans, res);
        if (st.size() == k - 1 && v[i] > *st.begin())
            sm -= *st.begin(), 
            st.erase(st.begin());
        if (st.size() < k - 1)
            st.insert(v[i]), 
            sm += v[i];
    }
    cout << ans << '\n';
}
